var swatch = document.getElementById("cvSwatch");
swatch.width = swatch.height = 40;
var sCtx = swatch.getContext("2d");

Picture.init(); // here to ensure doc has loaded

function testColour(tint){
    sCtx.clearRect(0, 0, swatch.width, swatch.height);
    sCtx.beginPath();
    sCtx.rect(0,0, 40, 40);
    sCtx.fillStyle = "#" + tint;
    sCtx.fill();
    sCtx.closePath();
}
Paint.setCallback(testColour);

document.getElementById("inpAlpha").addEventListener("input", function(){
    Paint.setAlpha(this.value / 100);
    document.getElementById("lblA").innerHTML = "Alpha " + this.value + "%";
});
document.getElementById("inpBrush").addEventListener("input", function(){
    Picture.setBrush(this.value);
    document.getElementById("lblB").innerHTML = "Brush " + this.value + "px";
});
Touch.addTouch("dvRed", {onDown: Paint.addColour});
Touch.addTouch("dvGreen", {onDown: Paint.addColour});
Touch.addTouch("dvBlue", {onDown: Paint.addColour});
Touch.addTouch("dvBlack", {onDown: Paint.addColour});
Touch.addTouch("cvMain", {onDown: Picture.touchStart, onMove: Picture.touchMove});
