var Colour = function(val){
    this.setColour(val);
    this.alpha = 1;
};
Colour.prototype.blend = function(tint){
    let t = new Colour(tint);
    this.red = Math.min(this.red + t.red, 255);
    this.green = Math.min(this.green + t.green, 255);
    this.blue = Math.min(this.blue + t.blue, 255);
};
Colour.prototype.blend2 = function(tint){
    let t = new Colour(tint);
    this.red = this.red | t.red;
    this.green = this.green | t.green;
    this.blue = this.blue | t.blue;
};
Colour.prototype.setAlpha = function(alpha){
    this.alpha = alpha;
};
Colour.prototype.setColour = function(val){
    this.red = parseInt(val.substring(0,2), 16);
    this.green = parseInt(val.substring(2,4), 16);
    this.blue = parseInt(val.substring(4), 16);
};
Colour.prototype.toString = function() {
    let opacity = Math.round(this.alpha * 255);
    return this.red.toString(16).padStart(2, "0") +
            this.green.toString(16).padStart(2, "0") +
            this.blue.toString(16).padStart(2, "0") +
            opacity.toString(16).padStart(2, "0");
};
var Paint = {
    lastSet: Date.now(),
    current: new Colour("ffffff"),
    callBack: null,
    addColour: function(pBoxId){
            let dvPal = document.getElementById(pBoxId);
            let data = dvPal.dataset.colour;
            if(Date.now() - Paint.lastSet > 1000){
                Paint.current.setColour(data);
             } else {
                Paint.current.blend(data);
            }
        Paint.lastSet = Date.now();
        if(Paint.callBack){
            Paint.callBack(Paint.getColour());
        }
    },
    setAlpha: function(alpha){
        this.current.setAlpha(alpha);
        if(this.callBack){
            this.callBack(this.getColour());
        }
    },
    getColour: function() {
        return this.current.toString();
    },
    setCallback: function(func){
        this.callBack = func;
    }
};
