var Picture = {
    canvas: null,
    ctx: null,
    xPos: 0,
    yPos: 0,
    brush: 8,
    init: function() {
        this.canvas = document.getElementById("cvMain");
        this.ctx = this.canvas.getContext("2d");
        let dv = document.getElementById("dvCanv");
        let rect = dv.getBoundingClientRect(); // where the div is within the document
        this.xPos = rect.left;
        this.yPos = rect.top;
        this.canvas.width = dv.clientWidth;
        this.canvas.height = dv.clientHeight;
    },
    touchStart: function(id, data){
        let col = Paint.getColour();
        Picture.ctx.beginPath();
        Picture.ctx.arc(data.x - Picture.xPos, data.y - Picture.yPos, Picture.brush / 2, 0, Math.PI * 2, false);
        Picture.ctx.fillStyle = "#" + col;
        Picture.ctx.fill();
        Picture.ctx.closePath();
    },
    setBrush: function(val) {
        this.brush = val;
    },
    // touchMove first version
    // touchMove: function(id, data){
    //     let col = Paint.getColour();
    //     Picture.ctx.beginPath();
    //     Picture.ctx.arc(data.x - Picture.xPos, data.y - Picture.yPos, Picture.brush, 0, Math.PI * 2, false);
    //     Picture.ctx.fillStyle = "#" + col;
    //     Picture.ctx.fill();
    //     Picture.ctx.closePath();
    // },
    touchMove: function(id, data){
        let col = Paint.getColour();
        let dx = data.x - data.lastX;
        let dy = data.y - data.lastY;
        let steps = Math.max(Math.abs(dy), Math.abs(dx));
        for(let p = 0; p < steps; p++){
            Picture.ctx.beginPath();
            data.lastX += dx / steps;
            data.lastY += dy /steps;
            Picture.ctx.arc(data.lastX - Picture.xPos, data.lastY - Picture.yPos, Picture.brush / 2, 0, Math.PI * 2, false);
            Picture.ctx.fillStyle = "#" + col;
            Picture.ctx.fill();
            Picture.ctx.closePath();
        }
    }
};
