var Touch = {
    elems: [],
    addTouch: function(elemId, options){
        let opts = this._setOptions(options);
        opts.elemId = elemId;
        opts.touchDown = false; // add some non-optional values
        opts.lastX = 0;
        opts.lastY = 0;
        let elem = document.getElementById(elemId);
        let me = this;
        // in the next lines "this" would refer to the HTML element and not the
        // Touch code module so use the variable "me" set above
        elem.addEventListener("pointerdown", function(e) {me._start(e);}, true);
        elem.addEventListener("pointermove", function(e) {me._move(e);}, true);
        elem.addEventListener("pointerup", function(e) {me._end(e);}, false);
        this.elems.push(opts);
    },
    _setOptions: function(options){
        let opts = {
            onDown: null,
            onMove: null,
            onUp: null,
            multiPoint: false,
            preventDefault: true
        };
        for (const opt in options){
            for(const def in opts) {
                if(opt === def){
                    opts[opt] = options[opt];
                    break;
                }
            }
        }
        return opts;
    },
    _start: function(e){
        for(let s=0; s < this.elems.length; s++){
            if(this.elems[s].elemId === e.currentTarget.id) {
                let el = this.elems[s];
                if(el.preventDefault){
                    e.preventDefault();
                }
                let dta = {
                    x: e.clientX,
                    y: e.clientY
                };
                el.touchDown = true;
                el.lastX = e.clientX;
                el.lastY = e.clientY;
                if(el.onDown){
                    el.onDown(el.elemId, dta);
                }
                break;
            }
        }
    },
    _move: function(e) {
        for(let s=0; s < this.elems.length; s++){
            if(this.elems[s].elemId === e.currentTarget.id) {
                let el = this.elems[s];
                if(el.preventDefault){
                    e.preventDefault();
                }
                if(el.onMove && el.touchDown){
                    let dta = {
                        x: e.clientX,
                        y: e.clientY,
                        lastX: el.lastX,
                        lastY: el.lastY
                    };
                    el.lastX = dta.x;
                    el.lastY = dta.y;
                    el.onMove(el.elemId, dta);
                }
                break;
            }
        }
    },
    _end: function(e) {
        for(let s=0; s < this.elems.length; s++){
            if(this.elems[s].elemId === e.currentTarget.id) {
                this.elems[s].touchDown = false;
            }
        }
    }
};