var Touch = {
    elems: [],
    addTouch: function(elemId, options){
        let opts = this._setOptions(options);
        opts.elemId = elemId;
        let elem = document.getElementById(elemId);
        let me = this;
        elem.addEventListener("pointerdown", function(e) {me._start(e);}, true);
        elem.addEventListener("pointermove", function(e) {me._move(e);}, true);
        elem.addEventListener("pointerup", function(e) {me._end(e);}, false);
        this.elems.push(opts);
    },
    _setOptions: function(options){
        let opts = {
            onDown: null,
            onMove: null,
            onUp: null,
            preventDefault: true
        };
        for (const opt in options){
            for(const def in opts) {
                if(opt === def){
                    opts[opt] = options[opt];
                    break;
                }
            }
        }
        return opts;
    },
    _start: function(e){
        for(let s=0; s < this.elems.length; s++){
            if(this.elems[s].elemId === e.currentTarget.id) {
                let el = this.elems[s];
                if(el.preventDefault){
                    e.preventDefault();
                }
                let dta = {
                    x: e.clientX,
                    y: e.clientY
                };
                if(el.onDown){
                    el.onDown(el.elemId);
                }
                break;
            }
        }
    },
    _move: function(e) {
        for(let s=0; s < this.elems.length; s++){
            if(this.elems[s].elemId === e.currentTarget.id) {
                let el = this.elems[s];
                if(el.preventDefault){
                    e.preventDefault();
                }
                if(el.onMove){
                    let dta = {
                        x: e.clientX,
                        y: e.clientY,
                    };
                    el.onMove(el.elemId, dta);
                }
                break;
            }
        }
    },
    _end: function(e) {
    }
};